//====================================================
// Shaders
// By Wang Jing(wjing_a@yahoo.com)
//====================================================
//--------------
// un-tweaks
//--------------
#define DCC_MAX
string ParamID = "0x003";

float4x4 WorldIT : WorldInverseTranspose ;
float4x4 WorldViewProj : WORLDVIEWPROJECTION ;
float4x4 World : World ;
float4x4 ViewInv : ViewInverse ;
float4 ClearColor  = {0,0,0,1.0};
float ClearDepth = 1.0;

//--------------
// Tweaks
//--------------
float3 LightPos1: POSITION <
	string UIName = "Light1 Position";
	string Object = "PointLight";
	string Space = "World";
> = {-1.0f, 1.0f, 0.0f};


float4 Light1Color  <
    string UIName = "Light1 Color ";
	string UIWidget = "Color";
>
= {0.0f, 0.0f, 0.0f, 0.0f};

float lp1<
    string UIWidget = "slider";
    string UIName = "Light1 power1";
    float UIMin = 0.0;
    float UIMax = 1024.0;
    float UIStep = 0.1;
> = 1.0;

float sb<
    string UIWidget = "slider";
    string UIName = "Light1 power2";
    float UIMin = 0.0;
    float UIMax = 4.0;
    float UIStep = 1.0;
> = 1.0;

float3 LightPos2: POSITION <
	string UIName = "Light2 Position";
	string Object = "PointLight";
	string Space = "World";
> = {-1.0f, 1.0f, 0.0f};


float4 Light2Color  <
    string UIName = "Light2 Color ";
	string UIWidget = "Color";
>
= {0.0f, 0.0f, 0.0f, 0.0f};

float lp2<
    string UIWidget = "slider";
    string UIName = "Light2 power1";
    float UIMin = 0.0;
    float UIMax = 1024.0;
    float UIStep = 0.1;
> = 1.0;

float sb1<
    string UIWidget = "slider";
    string UIName = "Light2 power2";
    float UIMin = 0.0;
    float UIMax = 4.0;
    float UIStep = 1.0;
> = 1.0;


float IBL1 <
    string UIWidget = "IntSpinner";
    half UIMin = 0.0;
    half UIMax = 100.0;   
    string UIName =  "IBL1";
> = 1.0;

float IBL2 <
    string UIWidget = "IntSpinner";
    half UIMin = 0.0;
    half UIMax = 100.0;   
    string UIName =  "IBL2";
> = 1.0;

float IBL3 <
    string UIWidget = "IntSpinner";
    half UIMin = 0.0;
    half UIMax = 100.0;  
    string UIName =  "IBL3";
> = 1.0;


float SpecExpon  <
    string UIWidget = "IntSpinner";
    half UIMin = 0.01;
    half UIMax = 1024.0;
    string UIName =  "Specular power";
> = 1.0;

float Bumpx<
    string UIWidget = "IntSpinner";
    half UIMin = -150.0;
    half UIMax = 150.0;   
    string UIName =  "Bumpx";
> = 1.0;

float Bumpy<
    string UIWidget = "IntSpinner";
    half UIMin = -150.0;
    half UIMax = 150.0;   
    string UIName =  "Bumpy";
> = 1.0;



float ap<
    string UIWidget = "slider";
    string UIName = "Ao power";
    float UIMin = 1.0;
    float UIMax = 1024.0;
    float UIStep = 1.0;
> = 1.0;
float sp<
    string UIWidget = "slider";
    string UIName = "Spe power";
    float UIMin =1.0;
    float UIMax = 1024.0;
    float UIStep = 1.0;
> = 1.0;
float gp<
    string UIWidget = "slider";
    string UIName = "Gloss power";
    float UIMin = 1.0;
    float UIMax = 1024.0;
    float UIStep = 1.0;
> = 1.0;
float ep1<
    string UIWidget = "slider";
    string UIName = "Emissive1 power";
    float UIMin =0.0;
    float UIMax = 1024.0;
    float UIStep = 0.1;
> = 1.0;

float Max <
    string UIWidget = "IntSpinner";
    half UIMin = 0.0;
    half UIMax = 100;   
    string UIName =  "Refl Max";
> = 1.0;


float Min <
    string UIWidget = "IntSpinner";
    half UIMin = 0.0;
    half UIMax = 1;
    string UIName =  "Refl Min";
> = 0;

float Fres  <
    string UIWidget = "IntSpinner";
    half UIMin = 1.0;
    half UIMax = 100.0;
    string UIName =  "Fres";
> = 1.0;
float f1 <
	string UIName = "Base Strength";
	string UIWidget = "slider";
	float UIMin = 0.0;
	float UIMax = 30.0;
	float UIStep = 0.01;
> = 1.0;


float Glowness <
    string UIName = "Glow Strength";
	string UIWidget = "slider";
	float UIMin = 0.0;
	float UIMax = 30.0;
	float UIStep = 0.01;
> = 2.0;



//--------------
// Textures
//--------------

texture colorTexture1 : Diffuse<  
	string UIName = "Diffuse Texture";
	int Texcoord = 0;
	int MapChannel = 1;			
	>;
texture normalTexture1 : Normal< 
	string UIName = "Normal Texture";
	int Texcoord = 0;
	int MapChannel = 1;	
	>;	
texture aoTexture1 <  
	string UIName = "Ao Texture";
	int Texcoord = 0;
	int MapChannel = 1;			
	>;
	
texture specularTexture1 <  
	string UIName = "Specular Texture";
	int Texcoord = 0;
	int MapChannel = 1;			
	>;
texture specularlevelTexture1 <  
	string UIName = "SpecularLevel Texture";
	int Texcoord = 0;
	int MapChannel = 1;			
	>;	
texture glossTexture1 <  
	string UIName = "Gloss Texture";
	int Texcoord = 0;
	int MapChannel = 1;			
	>;		
texture emissiveTexture1 <  
	string UIName = "Emissive Texture";
	int Texcoord = 0;
	int MapChannel = 1;			
	>;


texture envTexture <
    string UIName = "Diffuse CubeMap";	
    string ResourceType = "CUBE";
>;

texture envTexture1 <
    string UIName = "CubeMap";	
    string ResourceType = "CUBE";
>;

sampler colorSampler1 = sampler_state
{
    Texture   = (colorTexture1);
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    AddressU = Wrap;
	AddressV = Wrap;

};
sampler normalSampler1 = sampler_state {
	Texture = (normalTexture1);
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
	AddressU = Wrap;
	AddressV = Wrap;

};

sampler aoSampler1 = sampler_state
{
    Texture   = (aoTexture1);
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    AddressU = Wrap;
	AddressV = Wrap;

};


sampler specularSampler1 = sampler_state
{
    Texture   = (specularTexture1);
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    AddressU = Wrap;
	AddressV = Wrap;

};

sampler specularlSampler1 = sampler_state
{
    Texture   = (specularlevelTexture1);
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    AddressU = Wrap;
	AddressV = Wrap;

};
sampler glossSampler1 = sampler_state
{
    Texture   = (glossTexture1);
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    AddressU = Wrap;
	AddressV = Wrap;

};
sampler emissiveSampler1 = sampler_state
{
    Texture   = (emissiveTexture1);
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    AddressU = Wrap;
	AddressV = Wrap;

};


samplerCUBE envSampler = sampler_state {
	Texture = (envTexture);
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
	AddressU = clamp;
	AddressV = clamp;
	AddressW = clamp;
};
samplerCUBE envSampler1 = sampler_state {
	Texture = (envTexture1);
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
	AddressU = clamp;
	AddressV = clamp;
	AddressW = clamp;
};


#define RTT_SIZE 256

float TexelIncrement <
    string UIName = "Texel Stride for Blur";
    string UIWidget = "None";
> = 1.0f / RTT_SIZE;

texture GlowMap1 : RENDERCOLORTARGET < 
	float2 Dimensions = { RTT_SIZE, RTT_SIZE };
    int MIPLEVELS = 1;
    string format = "X8R8G8B8";
    string UIWidget = "None";
>;

sampler GlowSamp1 = sampler_state 
{
    texture = <GlowMap1>;
    AddressU  = CLAMP;        
    AddressV  = CLAMP;
    AddressW  = CLAMP;
    MIPFILTER = NONE;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};

texture GlowMap2 : RENDERCOLORTARGET < 
	float2 Dimensions = { RTT_SIZE, RTT_SIZE };
    int MIPLEVELS = 1;
    string format = "X8R8G8B8";
    string UIWidget = "None";
>;

sampler GlowSamp2 = sampler_state 
{
    texture = <GlowMap2>;
    AddressU  = CLAMP;        
    AddressV  = CLAMP;
    AddressW  = CLAMP;
    MIPFILTER = NONE;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};

texture DepthBuffer : RENDERDEPTHSTENCILTARGET
<
	float2 Dimensions = { RTT_SIZE, RTT_SIZE };
    string format = "D24S8";
    string UIWidget = "None";
>;

struct VS_OUTPUT_BLUR
{
    float4 Position   : POSITION;
    float4 Diffuse    : COLOR0;
    float4 TexCoord0   : TEXCOORD0;
    float4 TexCoord1   : TEXCOORD1;
    float4 TexCoord2   : TEXCOORD2;
    float4 TexCoord3   : TEXCOORD3;
    float4 TexCoord4   : TEXCOORD4;
    float4 TexCoord5   : TEXCOORD5;
    float4 TexCoord6   : TEXCOORD6;
    float4 TexCoord7   : TEXCOORD7;
    float4 TexCoord8   : COLOR1;   
};

struct VS_OUTPUT
{
   	float4 Position   : POSITION;
       float4 TexCoord0   : TEXCOORD0;
};




VS_OUTPUT VS(float3 Position : POSITION, 
			float3 Normal : NORMAL,
			float3 TexCoord : TEXCOORD0)
{
    VS_OUTPUT OUT = (VS_OUTPUT)0;
    OUT.Position = mul(float4(Position, 1), WorldViewProj); 
      OUT.TexCoord0 = float4(TexCoord, 1);
    return OUT;
}

VS_OUTPUT VS_Quad(float3 Position : POSITION, 
			float3 TexCoord : TEXCOORD0)
{
    VS_OUTPUT OUT = (VS_OUTPUT)0;
    OUT.Position = float4(Position, 1);
    OUT.TexCoord0 = float4(TexCoord, 1); 
    return OUT;
}

VS_OUTPUT_BLUR VS_Quad_Vertical_9tap(float3 Position : POSITION, 
			float3 TexCoord : TEXCOORD0)
{
    VS_OUTPUT_BLUR OUT = (VS_OUTPUT_BLUR)0;
    OUT.Position = float4(Position, 1);
    
    float3 Coord = float3(TexCoord.x + TexelIncrement, TexCoord.y + TexelIncrement, 1);
    OUT.TexCoord0 = float4(Coord.x, Coord.y + TexelIncrement, TexCoord.z, 1);
    OUT.TexCoord1 = float4(Coord.x, Coord.y + TexelIncrement * 2, TexCoord.z, 1);
    OUT.TexCoord2 = float4(Coord.x, Coord.y + TexelIncrement * 3, TexCoord.z, 1);
    OUT.TexCoord3 = float4(Coord.x, Coord.y + TexelIncrement * 4, TexCoord.z, 1);
    OUT.TexCoord4 = float4(Coord.x, Coord.y, TexCoord.z, 1);
    OUT.TexCoord5 = float4(Coord.x, Coord.y - TexelIncrement, TexCoord.z, 1);
    OUT.TexCoord6 = float4(Coord.x, Coord.y - TexelIncrement * 2, TexCoord.z, 1);
    OUT.TexCoord7 = float4(Coord.x, Coord.y - TexelIncrement * 3, TexCoord.z, 1);
    OUT.TexCoord8 = float4(Coord.x, Coord.y - TexelIncrement * 4, TexCoord.z, 1);
    return OUT;
}

VS_OUTPUT_BLUR VS_Quad_Horizontal_9tap(float3 Position : POSITION, 
			float3 TexCoord : TEXCOORD0)
{
    VS_OUTPUT_BLUR OUT = (VS_OUTPUT_BLUR)0;
    OUT.Position = float4(Position, 1);
    
    float3 Coord = float3(TexCoord.x + TexelIncrement, TexCoord.y + TexelIncrement, 1);
    OUT.TexCoord0 = float4(Coord.x + TexelIncrement, Coord.y, TexCoord.z, 1);
    OUT.TexCoord1 = float4(Coord.x + TexelIncrement * 2, Coord.y, TexCoord.z, 1);
    OUT.TexCoord2 = float4(Coord.x + TexelIncrement * 3, Coord.y, TexCoord.z, 1);
    OUT.TexCoord3 = float4(Coord.x + TexelIncrement * 4, Coord.y, TexCoord.z, 1);
    OUT.TexCoord4 = float4(Coord.x, Coord.y, TexCoord.z, 1);
    OUT.TexCoord5 = float4(Coord.x - TexelIncrement, Coord.y, TexCoord.z, 1);
    OUT.TexCoord6 = float4(Coord.x - TexelIncrement * 2, Coord.y, TexCoord.z, 1);
    OUT.TexCoord7 = float4(Coord.x - TexelIncrement * 3, Coord.y, TexCoord.z, 1);
    OUT.TexCoord8 = float4(Coord.x - TexelIncrement * 4, Coord.y, TexCoord.z, 1);
    return OUT;
}

#define WT9_0 1.0
#define WT9_1 0.8
#define WT9_2 0.6
#define WT9_3 0.4
#define WT9_4 0.2
#define WT9_NORMALIZE (WT9_0+2.0*(WT9_1+WT9_2+WT9_3+WT9_4))

float4 PS_Blur_Horizontal_9tap(VS_OUTPUT_BLUR IN) : COLOR
{   
    float4 OutCol = tex2D(GlowSamp1, IN.TexCoord0) * (WT9_1/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp1, IN.TexCoord1) * (WT9_2/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp1, IN.TexCoord2) * (WT9_3/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp1, IN.TexCoord3) * (WT9_4/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp1, IN.TexCoord4) * (WT9_0/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp1, IN.TexCoord5) * (WT9_1/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp1, IN.TexCoord6) * (WT9_2/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp1, IN.TexCoord7) * (WT9_3/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp1, IN.TexCoord8) * (WT9_3/WT9_NORMALIZE);
    return Glowness*OutCol;
} 

float4 PS_Blur_Vertical_9tap(VS_OUTPUT_BLUR IN) : COLOR
{   
    float4 OutCol = tex2D(GlowSamp2, IN.TexCoord0) * (WT9_1/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp2, IN.TexCoord1) * (WT9_2/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp2, IN.TexCoord2) * (WT9_3/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp2, IN.TexCoord3) * (WT9_4/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp2, IN.TexCoord4) * (WT9_0/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp2, IN.TexCoord5) * (WT9_1/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp2, IN.TexCoord6) * (WT9_2/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp2, IN.TexCoord7) * (WT9_3/WT9_NORMALIZE);
    OutCol += tex2D(GlowSamp2, IN.TexCoord8) * (WT9_3/WT9_NORMALIZE);
    return Glowness*OutCol;
} 

float4 PS_GlowPass(VS_OUTPUT IN) : COLOR
{   
	float4 tex = tex2D(GlowSamp1, float2(IN.TexCoord0.x, IN.TexCoord0.y));
	return tex;
} 

//--------------
// vertex shader
//--------------
VertexShader VSb = 
asm{
 vs_2_0
    dcl_position v0
    dcl_texcoord v1
    dcl_texcoord1 v2
    dcl_normal v3
    dcl_tangent v4
    dcl_binormal v5
    dp4 oT6.x, v4, c8
    dp4 oT6.y, v4, c9
    dp4 oT6.z, v4, c10
    dp4 oT7.x, v5, c8
    dp4 oT7.y, v5, c9
    dp4 oT7.z, v5, c10
    dp4 oPos.x, v0, c0
    dp4 oPos.y, v0, c1
    dp4 oPos.z, v0, c2
    dp4 oPos.w, v0, c3
    mov oT0, v1
    mov oT1, v2
    dp4 r0.x, v0, c4
    dp4 r0.y, v0, c5
    dp4 r0.z, v0, c6
    add r2.xyz, -r0, c14
    add r1.xyz, -r0, c15
    dp3 r4.x, r2, r2
    dp3 r3.x, r1, r1
    rsq r2.w, r4.x
    rsq r1.w, r3.x
    mov oT2, r2
    mov oT3, r1
    mov oT4.xyz, v3
    dp4 r0.w, v0, c7
    mov oT5, r0
    mov oD1.x, c11.w
    mov oD1.y, c12.w
    mov oD1.z, c13.w
};

//--------------
// pixel shader
//--------------
PixelShader PS = 
		asm {
    ps_3_0
    def c22, 1, 2, -1, 0
    def c23, 4, -2, 3, 0
    dcl_texcoord_pp v1.xy
    dcl_texcoord2_pp v3.xyz
    dcl_texcoord3_pp v4.xyz
    dcl_texcoord4_pp v5.xyz
    dcl_texcoord5_pp v6.xyz
    dcl_color1_pp v7.xyz
    dcl_texcoord6_pp v8.xyz
    dcl_texcoord7_pp v9.xyz
    dcl_2d s0
    dcl_2d s1
    dcl_2d s2
    dcl_2d s3
    dcl_2d s4
    dcl_2d s5
    dcl_2d s6
    dcl_cube s7
    dcl_cube s8
    texld r0, v1, s4
    add r1.w, -r0.x, c22.x
    mov r2.x, c13.x
    mov r2.y, c14.x
    texld r0, v1, s1
    mad_pp r1.xy, c22.y, r0, c22.z
    mul_pp r3.xy, r2, r1
    dp3 r1.x, v5, c0
    dp3 r1.y, v5, c1
    dp3 r1.z, v5, c2
    nrm_pp r2.xyz, v8
    dp3 r0.w, r1, r1
    mul_pp r2.xyz, r3.x, r2
    rsq r0.w, r0.w
    mad_pp r2.xyz, r1, r0.w, r2
    nrm_pp r1.xyz, v9
    add r1.w, -r1.w, c16.x
    mad_pp r1.xyz, r3.y, r1, r2
    nrm_pp r2.xyz, r1
    nrm_pp r8.xyz, v3
    rcp r1.z, c16.x
    dp3_pp r0.w, r8, r2
    mul r4.w, r1.w, r1.z
    cmp r6.w, -r0.w, c22.w, c22.x
    mov r1.z, c23.x
    add r1.w, r1.z, -c5.x
    mul_sat_pp r0.w, r0.w, r6.w
    rcp r1.y, r1.w
    add r1.w, r0.w, -c5.x
    mad_pp r6.xyz, c22.y, r0, c22.z
    mul_sat r0.z, r1.y, r1.w
    add r0.w, r0.w, c5.x
    mad r0.y, r0.z, c23.y, c23.z
    mul r0.x, r0.z, r0.z
    add r0.z, r1.z, c5.x
    mul r1.y, r0.y, r0.x
    rcp r0.z, r0.z
    mul_sat r0.z, r0.w, r0.z
    nrm_pp r7.xyz, v4
    mad r0.x, r0.z, c23.y, c23.z
    dp3_pp r0.w, r7, r2
    mul r1.w, r0.z, r0.z
    cmp r7.w, -r0.w, c22.w, c22.x
    add r0.z, r1.z, -c8.x
    mul_sat_pp r0.w, r0.w, r7.w
    rcp r0.y, r0.z
    add r0.z, r0.w, -c8.x
    mad_pp r4.y, r0.x, r1.w, -r1.y
    mul_sat r0.y, r0.y, r0.z
    mad r0.z, r0.y, c23.y, c23.z
    mul r0.y, r0.y, r0.y
    add r0.w, r0.w, c8.x
    mul r1.w, r0.z, r0.y
    add r1.z, r1.z, c8.x
    mov_pp r0.xyz, v7
    add_pp r5.xyz, r0, -v6
    rcp r0.y, r1.z
    dp3_pp r0.z, r5, r5
    mul_sat r0.w, r0.w, r0.y
    rsq_pp r2.w, r0.z
    mad r0.z, r0.w, c23.y, c23.z
    mul_pp r3.xyz, r5, r2.w
    mul r0.y, r0.w, r0.w
    dp3 r0.w, -r3, r2
    mad_pp r4.z, r0.z, r0.y, -r1.w
    add r0.w, r0.w, r0.w
    add_pp r5.w, r4.y, r4.z
    mad_pp r0.xyz, r2.xzyw, -r0.w, -r3.xzyw
    texld r1, r0, s8
    texld r0, r0, s7
    mul_pp r1.xyz, r1, c11.x
    mul r1.xyz, r5.w, r1
    mul_pp r0.xyz, r0, c10.x
    dp3_pp r3.w, r3, r2
    mad r0.xyz, r0, r5.w, r1
    mad r0.xyz, c3, r4.y, r0
    mul r3.xyz, r4.y, c3
    mad r0.xyz, c6, r4.z, r0
    mul r4.xyz, r4.z, c6
    mul r1.xyz, r4.w, r0
    mad_pp r9.xyz, r5, r2.w, r7
    mad_pp r5.xyz, r5, r2.w, r8
    nrm_pp r0.xyz, r9
    dp3_sat_pp r2.w, r6, r8
    dp3_pp r1.w, r0, r2
    dp3_sat_pp r4.w, r6, r7
    cmp r0.w, -r1.w, c22.w, c22.x
    pow r0.z, r1.w, c12.x
    mul r0.w, r7.w, r0.w
    mul_sat_pp r0.w, r0.z, r0.w
    nrm_pp r0.xyz, r5
    mul r1.w, r0.w, c7.x
    dp3_pp r5.z, r0, r2
    texld r0, r2.xzyw, s7
    cmp r0.w, -r5.z, c22.w, c22.x
    pow r2.z, r5.z, c12.x
    mul r0.w, r6.w, r0.w
    mul_sat_pp r0.w, r2.z, r0.w
    mad r0.w, r0.w, c4.x, r1.w
    mul r2.xyz, r1, r0.w
    texld r1, v1, s3
    add_pp r0.w, -r3_abs.w, c22.x
    mul_pp r2.xyz, r2, r1
    pow r1.w, r0.w, c21.x
    mov r0.w, c19.x
    add r0.w, r0.w, -c20.x
    mul r1.xyz, r4, c7.x
    mad r1.xyz, r3, c4.x, r1
    mul_pp r0.xyz, r0, c9.x
    mad_pp r3.w, r0.w, r1.w, c20.x
    mad r3.xyz, r0, r5.w, r1
    texld r0, v1, s0
    texld r1, v1, s2
    add r1.w, -r1.x, c22.x
    add r1.w, -r1.w, c15.x
    rcp r4.z, c15.x
    mul r1.xyz, r3, r0
    mul r1.w, r1.w, r4.z
    mul_pp r3.xyz, r2, r3.w
    mul_pp r0.xyz, r1, r1.w
    mad_pp r2.xyz, r1, r1.w, r2
    mul r1.w, r4.w, c7.x
    mul_pp r0.xyz, r3.w, r0
    mad r2.w, r2.w, c4.x, r1.w
    texld r1, v1, s5
    add r1.w, -r1.x, c22.x
    add r1.w, -r1.w, c17.x
    rcp r1.z, c17.x
    mad r0.xyz, r0, r2.w, r3
    mul r1.w, r1.w, r1.z
    mad_pp r0.xyz, r0, r1.w, r2
    texld r1, v1, s6
    mad_pp r0.xyz, r1, c18.x, r0
    mov_pp oC0.w, r0.w
    add_pp oC0.xyz, r0, r0
};
PixelShader PSb = 
		asm {
		  ps_3_0
    def c23, 1, 2, -1, 0
    def c24, 4, -2, 3, 0
    dcl_texcoord_pp v1.xy
    dcl_texcoord2_pp v3.xyz
    dcl_texcoord3_pp v4.xyz
    dcl_texcoord4_pp v5.xyz
    dcl_texcoord5_pp v6.xyz
    dcl_color1_pp v7.xyz
    dcl_texcoord6_pp v8.xyz
    dcl_texcoord7_pp v9.xyz
    dcl_2d s0
    dcl_2d s1
    dcl_2d s2
    dcl_2d s3
    dcl_2d s4
    dcl_2d s5
    dcl_2d s6
    dcl_cube s7
    dcl_cube s8
    texld r0, v1, s4
    add r1.w, -r0.x, c23.x
    mov r2.x, c13.x
    mov r2.y, c14.x
    texld r0, v1, s1
    mad_pp r1.xy, c23.y, r0, c23.z
    mul_pp r3.xy, r2, r1
    dp3 r1.x, v5, c0
    dp3 r1.y, v5, c1
    dp3 r1.z, v5, c2
    nrm_pp r2.xyz, v8
    dp3 r0.w, r1, r1
    mul_pp r2.xyz, r3.x, r2
    rsq r0.w, r0.w
    mad_pp r2.xyz, r1, r0.w, r2
    nrm_pp r1.xyz, v9
    add r1.w, -r1.w, c16.x
    mad_pp r1.xyz, r3.y, r1, r2
    nrm_pp r2.xyz, r1
    nrm_pp r8.xyz, v3
    rcp r1.z, c16.x
    dp3_pp r0.w, r8, r2
    mul r4.w, r1.w, r1.z
    cmp r6.w, -r0.w, c23.w, c23.x
    mov r1.z, c24.x
    add r1.w, r1.z, -c5.x
    mul_sat_pp r0.w, r0.w, r6.w
    rcp r1.y, r1.w
    add r1.w, r0.w, -c5.x
    mad_pp r6.xyz, c23.y, r0, c23.z
    mul_sat r0.z, r1.y, r1.w
    add r0.w, r0.w, c5.x
    mad r0.y, r0.z, c24.y, c24.z
    mul r0.x, r0.z, r0.z
    add r0.z, r1.z, c5.x
    mul r1.y, r0.y, r0.x
    rcp r0.z, r0.z
    mul_sat r0.z, r0.w, r0.z
    nrm_pp r7.xyz, v4
    mad r0.x, r0.z, c24.y, c24.z
    dp3_pp r0.w, r7, r2
    mul r1.w, r0.z, r0.z
    cmp r7.w, -r0.w, c23.w, c23.x
    add r0.z, r1.z, -c8.x
    mul_sat_pp r0.w, r0.w, r7.w
    rcp r0.y, r0.z
    add r0.z, r0.w, -c8.x
    mad_pp r4.y, r0.x, r1.w, -r1.y
    mul_sat r0.y, r0.y, r0.z
    mad r0.z, r0.y, c24.y, c24.z
    mul r0.y, r0.y, r0.y
    add r0.w, r0.w, c8.x
    mul r1.w, r0.z, r0.y
    add r1.z, r1.z, c8.x
    mov_pp r0.xyz, v7
    add_pp r5.xyz, r0, -v6
    rcp r0.y, r1.z
    dp3_pp r0.z, r5, r5
    mul_sat r0.w, r0.w, r0.y
    rsq_pp r2.w, r0.z
    mad r0.z, r0.w, c24.y, c24.z
    mul_pp r3.xyz, r5, r2.w
    mul r0.y, r0.w, r0.w
    dp3 r0.w, -r3, r2
    mad_pp r4.z, r0.z, r0.y, -r1.w
    add r0.w, r0.w, r0.w
    add_pp r5.w, r4.y, r4.z
    mad_pp r0.xyz, r2.xzyw, -r0.w, -r3.xzyw
    texld r1, r0, s8
    texld r0, r0, s7
    mul_pp r1.xyz, r1, c11.x
    mul r1.xyz, r5.w, r1
    mul_pp r0.xyz, r0, c10.x
    dp3_pp r3.w, r3, r2
    mad r0.xyz, r0, r5.w, r1
    mad r0.xyz, c3, r4.y, r0
    mul r3.xyz, r4.y, c3
    mad r0.xyz, c6, r4.z, r0
    mul r4.xyz, r4.z, c6
    mul r1.xyz, r4.w, r0
    mad_pp r9.xyz, r5, r2.w, r7
    mad_pp r5.xyz, r5, r2.w, r8
    nrm_pp r0.xyz, r9
    dp3_sat_pp r2.w, r6, r8
    dp3_pp r1.w, r0, r2
    dp3_sat_pp r4.w, r6, r7
    cmp r0.w, -r1.w, c23.w, c23.x
    pow r0.z, r1.w, c12.x
    mul r0.w, r7.w, r0.w
    mul_sat_pp r0.w, r0.z, r0.w
    nrm_pp r0.xyz, r5
    mul r1.w, r0.w, c7.x
    dp3_pp r5.z, r0, r2
    texld r0, r2.xzyw, s7
    cmp r0.w, -r5.z, c23.w, c23.x
    pow r2.z, r5.z, c12.x
    mul r0.w, r6.w, r0.w
    mul_sat_pp r0.w, r2.z, r0.w
    mad r0.w, r0.w, c4.x, r1.w
    mul r2.xyz, r1, r0.w
    texld r1, v1, s3
    mul_pp r2.xyz, r2, r1
    add_pp r0.w, -r3_abs.w, c23.x
    pow r1.w, r0.w, c21.x
    mov r0.w, c19.x
    add r0.w, r0.w, -c20.x
    mad_pp r3.w, r0.w, r1.w, c20.x
    mul r1.xyz, r4, c7.x
    mad r1.xyz, r3, c4.x, r1
    mul_pp r0.xyz, r0, c9.x
    mul_pp r2.xyz, r2, r3.w
    mad r3.xyz, r0, r5.w, r1
    texld r0, v1, s0
    texld r1, v1, s2
    add r1.w, -r1.x, c23.x
    add r1.w, -r1.w, c15.x
    rcp r1.z, c15.x
    mul r0.xyz, r3, r0
    mul r1.w, r1.w, r1.z
    mul_pp r0.xyz, r0, r1.w
    mul r1.w, r4.w, c7.x
    mul_pp r0.xyz, r3.w, r0
    mad r2.w, r2.w, c4.x, r1.w
    texld r1, v1, s5
    add r1.w, -r1.x, c23.x
    add r1.w, -r1.w, c17.x
    rcp r1.z, c17.x
    mad r0.xyz, r0, r2.w, r2
    mul r1.w, r1.w, r1.z
    mul_pp r0.xyz, r0, r1.w
    mul r0.xyz, r0, c22.x
    texld r1, v1, s6
    mul r1.xyz, r1, c18.x
    mad_pp r0.xyz, r0, r0.w, r1
    mov_pp oC0.w, r0.w
    add_pp oC0.xyz, r0, r0	

};
//--------------
// techniques   
//--------------				
technique DirectX9
<
	string Script =
			"ClearSetColor=ClearColor;"
			"ClearSetDepth=ClearDepth;"
			"Pass=BlurPass;"      	
	        	"Pass=BlurGlowBuffer_Horz;"
		        "Pass=BlurGlowBuffer_Vert;"
		        "Pass=ModelPass;"
		      	"Pass=GlowPass;";
>	        
{
	pass BlurPass
	<
    	string Script = "RenderColorTarget0=GlowMap1;"
    				"Clear=Color;"
				"Clear=Depth;"
				"Draw=Geometry;";
	>
	{
	    ZEnable = true;
	   ZWriteEnable = true;
	   CullMode = none; 
        AlphaTestEnable = TRUE;
        AlphaFunc 		= 7;
       AlphaRef 		= 350;	
       AlphaBlendEnable= TRUE;
       DestBlend 		= INVSRCALPHA;
       SrcBlend 		= SRCALPHA;
        VertexShader = <VSb>;
        PixelShader = <PSb>;
    VertexShaderConstant[0] = <WorldViewProj>;		
	VertexShaderConstant[4] = <World>;
	VertexShaderConstant[8] = <WorldIT>;
	VertexShaderConstant[11]  = <ViewInv>;
	VertexShaderConstant[14]  = <LightPos1>;
	VertexShaderConstant[15]  = <LightPos2>;
	PixelShaderConstant[0]=<WorldIT>;
	PixelShaderConstant[3]=<Light1Color>;	
	PixelShaderConstant[4]=<lp1>;
	PixelShaderConstant[5]=<sb>;
	PixelShaderConstant[6]=<Light2Color>;
	PixelShaderConstant[7]=<lp2>;
	PixelShaderConstant[8]=<sb1>;
	PixelShaderConstant[9]=<IBL1>;
	PixelShaderConstant[10]=<IBL2>;
	PixelShaderConstant[11]=<IBL3>;	
	PixelShaderConstant[12]=<SpecExpon>;
	PixelShaderConstant[13]=<Bumpx>;	
	PixelShaderConstant[14]=<Bumpy>;
	PixelShaderConstant[15]=<ap>;
	PixelShaderConstant[16]=<sp>;
	PixelShaderConstant[17]=<gp>;
    PixelShaderConstant[18]=<ep1>;
	PixelShaderConstant[19]=<Max>;
	PixelShaderConstant[20]=<Min>;
	PixelShaderConstant[21]=<Fres>;
    PixelShaderConstant[22]=<f1>;
    Sampler[0] 				= <colorSampler1>;
    Sampler[1] 				= <normalSampler1>;
    Sampler[2] 				= <aoSampler1>;
    Sampler[3] 				= <specularSampler1>;
    Sampler[4] 				= <specularlSampler1>;
    Sampler[5] 				= <glossSampler1>;
    Sampler[6] 				= <emissiveSampler1>;
    Sampler[7] 				= <envSampler>;
    Sampler[8] 				= <envSampler1>;
	}

    pass BlurGlowBuffer_Horz 
    < 
    	string Script ="RenderColorTarget0=GlowMap2;"
    			"Clear=Color;"
			"Clear=Depth;"

    							"Draw=Buffer;";
    >
	{
		cullmode = none;
		ZEnable = false;
		VertexShader = compile vs_2_0 VS_Quad_Horizontal_9tap();
		PixelShader  = compile ps_2_0 PS_Blur_Horizontal_9tap();
    }
    pass BlurGlowBuffer_Vert 
     <
    	string Script = "RenderColorTarget0=GlowMap1;"
    			"Clear=Color;"
			"Clear=Depth;"
			"Draw=Buffer;";
    >
    {
		cullmode = none;
		ZEnable = false;
		VertexShader = compile vs_2_0 VS_Quad_Vertical_9tap();
		PixelShader  = compile ps_2_0 PS_Blur_Vertical_9tap();
    }
   pass ModelPass
    <
    	string Script= "RenderColorTarget0=;"
						"Draw=Geometry;";
	>
	{
    ZEnable = true;
	   ZWriteEnable = true;
	   CullMode = none; 
        AlphaTestEnable = TRUE;
        AlphaFunc 		= 7;
       AlphaRef 		= 350;	
       AlphaBlendEnable= TRUE;
       DestBlend 		= INVSRCALPHA;
       SrcBlend 		= SRCALPHA;
    VertexShader = <VSb>;
    PixelShader = <PS>;
    VertexShaderConstant[0] = <WorldViewProj>;		
	VertexShaderConstant[4] = <World>;
	VertexShaderConstant[8] = <WorldIT>;
	VertexShaderConstant[11]  = <ViewInv>;
	VertexShaderConstant[14]  = <LightPos1>;
	VertexShaderConstant[15]  = <LightPos2>;
    VertexShaderConstant[0] = <WorldViewProj>;		
	VertexShaderConstant[4] = <World>;
	VertexShaderConstant[8] = <WorldIT>;
	VertexShaderConstant[11]  = <ViewInv>;
	VertexShaderConstant[14]  = <LightPos1>;
	VertexShaderConstant[15]  = <LightPos2>;
	PixelShaderConstant[0]=<WorldIT>;
	PixelShaderConstant[3]=<Light1Color>;	
	PixelShaderConstant[4]=<lp1>;
	PixelShaderConstant[5]=<sb>;
	PixelShaderConstant[6]=<Light2Color>;
	PixelShaderConstant[7]=<lp2>;
	PixelShaderConstant[8]=<sb1>;
	PixelShaderConstant[9]=<IBL1>;
	PixelShaderConstant[10]=<IBL2>;
	PixelShaderConstant[11]=<IBL3>;	
	PixelShaderConstant[12]=<SpecExpon>;
	PixelShaderConstant[13]=<Bumpx>;	
	PixelShaderConstant[14]=<Bumpy>;
	PixelShaderConstant[15]=<ap>;
	PixelShaderConstant[16]=<sp>;
	PixelShaderConstant[17]=<gp>;
    PixelShaderConstant[18]=<ep1>;
	PixelShaderConstant[19]=<Max>;
	PixelShaderConstant[20]=<Min>;
	PixelShaderConstant[21]=<Fres>;
    Sampler[0] 				= <colorSampler1>;
    Sampler[1] 				= <normalSampler1>;
    Sampler[2] 				= <aoSampler1>;
    Sampler[3] 				= <specularSampler1>;
    Sampler[4] 				= <specularlSampler1>;
    Sampler[5] 				= <glossSampler1>;
    Sampler[6] 				= <emissiveSampler1>;
    Sampler[7] 				= <envSampler>;
    Sampler[8] 				= <envSampler1>;
	}
    pass GlowPass 
    <
       	string Script= "RenderColorTarget0=;"
	   							"Draw=Buffer;";        	
	>
    {
		cullmode = none;
		ZEnable = false;
		ZWriteEnable = false;		
		ZFunc 		= LessEqual;
		AlphaBlendEnable = true;
		SrcBlend = srccolor;	
		DestBlend = one;
		VertexShader = compile vs_1_1 VS_Quad();
		PixelShader = compile ps_2_0 PS_GlowPass();	
    }
}



